

# sequential component normalization (SCN) - cis + trans
# input: raw matrix
# output normalized matrix

scn <- function(mat, max_iters = 1) {

  nr <- nrow(mat)
  nc <- ncol(mat)

  for (i in 1:max_iters) { 
    mat_tmp <- mat

	  rnorm <- apply(mat_tmp, 1, function(x) norm(x, type = "2"))
	  cnorm <- apply(mat_tmp, 2, function(x) norm(x, type = "2"))

	  expectedMat <- matrix(rnorm, nrow = nr) %*% cnorm
	  mat <- mat_tmp / expectedMat
	  mat[!is.finite(mat)] <- 0
	}
	mat <- round(mat, 6)
	return(mat)
}

