
# vanilla coverage (VC) - cis + trans
# input: raw matrix
# output normalized matrix

vc <- function(mat) {
  nr <- nrow(mat)
  nc <- ncol(mat)

  rsum <- rowSums(mat)
  rcol <- colSums(mat)

  expectedMat <- matrix(rsum, nrow = nr) %*% rcol

  mat2 <- mat / expectedMat
  mat2[!is.finite(mat2)] <- 0
	mat2 <- round(mat2, 6)
	
	return(mat2)
}

